from sdk32 import *

ps = PAINTSTRUCT()
rect = RECT()
divisions = 5
state = []
for i in range(divisions):
    state.append([0] * divisions)
xblock = yblock = 0

def wnd_proc(wnd, msg, wparam, lparam):
    global ps, rect, divisions, state, xblock, yblock
    if msg == WM_SIZE:
        xblock = LOWORD(lparam) / divisions
        yblock = HIWORD(lparam) / divisions
        return 0

    elif msg == WM_LBUTTONDOWN:
        x = LOWORD(lparam) / xblock
        y = HIWORD(lparam) / yblock
        if x < divisions and y < divisions:
            state[x][y] = not state[x][y]
            rect.left = x * xblock
            rect.top = y * yblock
            rect.right = (x + 1) * xblock
            rect.bottom = (y + 1) * yblock
            InvalidateRect(wnd, rect, FALSE)
        else:
            MessageBeep(0)
        return 0

    elif msg == WM_PAINT:
        dc = BeginPaint(wnd, ps)
        for x in range(divisions):
            for y in range(divisions):
                Rectangle(dc, x * xblock, y * yblock,
                          (x + 1) * xblock, (y + 1) * yblock)
                if state[x][y]:
                    MoveToEx(dc, x * xblock,       y * yblock, None)
                    LineTo(dc,   (x + 1) * xblock, (y + 1) * yblock)
                    MoveToEx(dc, x * xblock,       (y + 1) * yblock, None)
                    LineTo(dc,   (x + 1) * xblock, y * yblock)
        EndPaint(wnd, ps)
        return 0

    elif msg == WM_DESTROY:
        PostQuitMessage(0)
        return 0

    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'Checker1'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = GetStockObject(WHITE_BRUSH)
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'Checker1 Mouse Hit-Test Demo',
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam
