from sdk32 import *

ps = PAINTSTRUCT()
count = 0
points = [None] * 1000

def wnd_proc(wnd, msg, wparam, lparam):
    global ps, count
    if msg == WM_LBUTTONDOWN:
        count = 0
        InvalidateRect(wnd, None, 0)
        return 0

    elif msg == WM_MOUSEMOVE:
        if wparam & MK_LBUTTON and count < len(points):
            point = POINT()
            point.x = LOWORD(lparam)
            point.y = HIWORD(lparam)
            points[count] = point
            count += 1
            dc = GetDC(wnd)
            SetPixel(dc, LOWORD(lparam), HIWORD(lparam), 0)
            ReleaseDC(wnd, dc)
        return 0

    elif msg == WM_LBUTTONUP:
        InvalidateRect(wnd, None, FALSE)
        return 0

    elif msg == WM_PAINT:
        dc = BeginPaint(wnd, ps)
        for i in range(count - 1):
            for j in range(i, count):
                MoveToEx(dc, points[i].x, points[i].y, None)
                LineTo(dc, points[j].x, points[j].y)
        EndPaint(wnd, ps)
        return 0

    elif msg == WM_DESTROY:
        PostQuitMessage(0)
        return 0

    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'Connect'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = GetStockObject(WHITE_BRUSH)
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'Connect-the-Dots Mouse Demo',
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam
