from sdk32 import *

ps = PAINTSTRUCT()
rect = RECT()
tm = TEXTMETRIC()
xchar = ychar = 0

def show_key(wnd, itype, message, wparam, lparam):
    global rect, xchar, ychar
    ScrollWindow(wnd, 0, -ychar, rect, rect)
    dc = GetDC(wnd)
    SelectObject(dc, GetStockObject(SYSTEM_FIXED_FONT))
    s1 = s2 = 'No'
    if lparam & 0x01000000:
        s1 = 'Yes'
    if lparam & 0x02000000:
        s2 = 'Yes'
    s3 = 'Up'
    if lparam & 0x04000000:
        s3 = 'Down'
    s4 = 'Down'
    if lparam & 0x08000000:
        s4 = 'Up'
    if itype == 0:
        buff = '%-14s %3d    %c %6u %4d %3s %3s %4s %4s' \
               % (message, wparam, ' ',
                  LOWORD(lparam), HIWORD(lparam) & 0xff, s1, s2, s3, s4)
    else:
        buff = '%-14s    %3d %c %6u %4d %3s %3s %4s %4s' \
               % (message, wparam, wparam & 0xff,
                  LOWORD(lparam), HIWORD(lparam) & 0xff, s1, s2, s3, s4)
    TextOut(dc, xchar, rect.bottom - ychar, buff, len(buff))
    ReleaseDC(wnd, dc)
    ValidateRect(wnd, None)

top = 'Message         Key Char Repeat Scan Ext ALT Prev Tran'
und = '_______         ___ ____ ______ ____ ___ ___ ____ ____'

def wnd_proc(wnd, msg, wparam, lparam):
    global ps, rect, tm, xchar, ychar
    if msg == WM_CREATE:
        dc = GetDC(wnd)
        SelectObject(dc, GetStockObject(SYSTEM_FIXED_FONT));
        GetTextMetrics(dc, tm)
        xchar = tm.ave_char_width
        ychar = tm.height
        ReleaseDC(wnd, dc)
        rect.top = 3 * ychar / 2
        return 0

    elif msg == WM_SIZE:
        rect.right = LOWORD(lparam)
        rect.bottom = HIWORD(lparam)
        UpdateWindow(wnd)
        return 0

    elif msg == WM_PAINT:
        dc = BeginPaint(wnd, ps)
        SelectObject(dc, GetStockObject(SYSTEM_FIXED_FONT))
        SetBkMode(dc, TRANSPARENT)
        TextOut(dc, xchar, ychar / 2, top, len(top))
        TextOut(dc, xchar, ychar / 2, und, len(und))
        EndPaint(wnd, ps)
        return 0

    elif msg == WM_KEYDOWN:
        show_key(wnd, 0, 'WM_KEYDOWN', wparam, lparam)
        return 0

    elif msg == WM_KEYUP:
        show_key(wnd, 0, 'WM_KEYUP', wparam, lparam)
        return 0

    elif msg == WM_CHAR:
        show_key(wnd, 1, 'WM_CHAR', wparam, lparam)
        return 0

    elif msg == WM_DEADCHAR:
        show_key(wnd, 1, 'WM_DEADCHAR', wparam, lparam)
        return 0

    elif msg == WM_SYSKEYDOWN:
        show_key(wnd, 0, 'WM_SYSKEYDOWN', wparam, lparam)

    elif msg == WM_SYSKEYUP:
        show_key(wnd, 0, 'WM_SYSKEYUP', wparam, lparam)

    elif msg == WM_SYSCHAR:
        show_key(wnd, 1, 'WM_SYSCHAR', wparam, lparam)

    elif msg == WM_SYSDEADCHAR:
        show_key(wnd, 1, 'WM_SYSDEADCHAR', wparam, lparam)

    elif msg == WM_DESTROY:
        PostQuitMessage(0)
        return 0

    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'KeyLook'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = GetStockObject(WHITE_BRUSH)
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'Keyboard Message Looker',
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam
